纯净、安全、绿色的下载网站

首页|软件分类|下载排行|最新软件|IT学院

当前位置:首页IT学院IT技术

Java异常处理 一篇文章看懂Java异常处理

weixin_51178129   2021-11-19 我要评论
想了解一篇文章看懂Java异常处理的相关内容吗weixin_51178129在本文为您仔细讲解Java异常处理的相关知识和一些Code实例欢迎阅读和指正我们先划重点:java异常处理代码,java异常处理机制,java异常处理方法下面大家一起来学习吧

异常的定义

在java中异常就是java在编译、运行或运行过程中出现的错误

总共有三种:1.编译错误 2.运行错误 3.逻辑错误

1.编译错误是因为程序没有遵循语法规则编译程序能够自己发现并且提示我们错误的原因和位置这个也是新手在刚接触编程语言时经常遇到的问题

2.运行时错误是因为程序在执行时运行环境发现了不能执行的操作

3.逻辑错误是因为程序没有按照预期的逻辑顺序执行异常也就是指程序运行时发生错误而异常处理就是对这些错误进行处理和控制

package org.oracle.test;

public class TryDemo9 {
    public static void main(String[] args) {
    	        System.out.println(1/0);//0不能做除数
    	  
    	        System.out.println("你好");//程序捕获异常程序终止不执行
    }
}

在代码执行过程中遇到异常就会终止

运行的结果里会告诉我们异常的类型异常出现的位置

异常的分类

RuntimeException:运行时异常一般不手动处理出问题了再处理

其他Exception:必须要经过手动处理

Error:一般指的是系统级错误

异常的处理方法

try…catch处理

package org.oracle.test;
import java.util.Scanner;
public class TryDemo2 {
	public static void main(String[] args) {
		System.out.println(testOne());
	}	
	/*
	 *  当try、catch、finally代码块中都有return语句
	 *  程序无论报错与否都会执行finally里面的renturn语句
	 */
	public static double testOne() {
		try {
			Scanner sc = new Scanner(System.in);
			System.out.println("请输入第一个数字:");
			int a = sc.nextInt();
			System.out.println("请输入第二个数字:");
			int b = sc.nextInt();
			int result = a / b;
//			System.out.println("result:" + result);
			System.out.println("执行了try块");
			return result;		
		}catch (Exception e) {
			e.printStackTrace();
			return 0;
		}finally {
			return -1000;
		}
	}
}

运行结果:

try-- 用于监听将要被监听的代码(可能抛出异常的代码)放在try语句块之内当try语句块内发生异常时异常就被抛出

catch-- 用于捕获异常catch用来捕获try语句块中发生的异常

finally-- finally语句块总是会被执行它主要用于回收在try块里打开的物力资源(如数据库连接、网络连接和磁盘文件)

throw 和throws

throws表示方法准备要扔出来一个异常

throw表示向外抛出异常

package org.oracle.test;

import java.util.InputMismatchException;

public class TryDemo8 {
	public static void main(String[] args) {
		try {
			testThree();
		} catch (Exception e) {
			System.out.println(e.getMessage());
			e.printStackTrace();
		}
	}
	public static void testOne() throws InputMismatchException{
		throw new InputMismatchException();
	}
	public static void testTwo() throws Exception {
		try {
			testOne();
		} catch (InputMismatchException e) {
			throw new Exception("新异常1",e);
		}
	}

	public static void testThree() throws Exception {
		try {
			testTwo();
		} catch (Exception e) {
			Exception e1 = new Exception("新异常2");
			e1.initCause(e);
			throw e1;
		}
	}
}

运行结果:

自定义异常

自定义异常:直接继承Exception或者RuntimeException来是实现自定义异常

package org.oracle.test;

import java.util.Scanner;

public class TryDemo6 {

	public static void main(String[] args){
		try {
			hotelRule();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/*
	 * 	基帝开了个情侣酒店基帝酒店规矩:18岁以下和80岁上以上客户需要家人陪同入住
	 */
	public static void hotelRule() throws Exception {
		Scanner sc = new Scanner(System.in);
		System.out.println("请输入客户年龄:");
		int age = sc.nextInt();
		if(age < 18 || age > 80) {
			throw new HotelException();
		}else {
			System.out.println("成功入住");
		}
	}

}

package org.oracle.test;
/*
 * 自定义异常需继承Exception
 */
public class HotelException extends Exception{

	public HotelException() {
		super("由于年龄问题无法入住");
	}
	
}

运行结果:

总结


相关文章

猜您喜欢

网友评论

Copyright 2020 www.fresh-weather.com 【世纪下载站】 版权所有 软件发布

声明:所有软件和文章来自软件开发商或者作者 如有异议 请与本站联系 点此查看联系方式